//Code generated automatically by TMVA for Inference of Model file [trained_model.onnx] at [Thu Jul 11 15:26:27 2024] 

#ifndef ROOT_TMVA_SOFIE_TRAINED_MODEL
#define ROOT_TMVA_SOFIE_TRAINED_MODEL

#include <algorithm>
#include <vector>
#include "TMVA/SOFIE_common.hxx"
#include <fstream>

namespace TMVA_SOFIE_trained_model{
namespace BLAS{
	extern "C" void sgemv_(const char * trans, const int * m, const int * n, const float * alpha, const float * A,
	                       const int * lda, const float * X, const int * incx, const float * beta, const float * Y, const int * incy);
	extern "C" void sgemm_(const char * transa, const char * transb, const int * m, const int * n, const int * k,
	                       const float * alpha, const float * A, const int * lda, const float * B, const int * ldb,
	                       const float * beta, float * C, const int * ldc);
}//BLAS
struct Session {
std::vector<float> fTensor_sequentialdenseBiasAddReadVariableOp0 = std::vector<float>(64);
float * tensor_sequentialdenseBiasAddReadVariableOp0 = fTensor_sequentialdenseBiasAddReadVariableOp0.data();
std::vector<float> fTensor_sequentialdenseMatMulReadVariableOp0 = std::vector<float>(128);
float * tensor_sequentialdenseMatMulReadVariableOp0 = fTensor_sequentialdenseMatMulReadVariableOp0.data();
std::vector<float> fTensor_sequentialdense1MatMulReadVariableOp0 = std::vector<float>(4096);
float * tensor_sequentialdense1MatMulReadVariableOp0 = fTensor_sequentialdense1MatMulReadVariableOp0.data();
std::vector<float> fTensor_sequentialdense1BiasAddReadVariableOp0 = std::vector<float>(64);
float * tensor_sequentialdense1BiasAddReadVariableOp0 = fTensor_sequentialdense1BiasAddReadVariableOp0.data();
std::vector<float> fTensor_sequentialdense2BiasAddReadVariableOp0 = std::vector<float>(1);
float * tensor_sequentialdense2BiasAddReadVariableOp0 = fTensor_sequentialdense2BiasAddReadVariableOp0.data();
std::vector<float> fTensor_sequentialdense2MatMulReadVariableOp0 = std::vector<float>(64);
float * tensor_sequentialdense2MatMulReadVariableOp0 = fTensor_sequentialdense2MatMulReadVariableOp0.data();
//--- declare the dynamic tensors
std::vector<float> fTensor_sequentialdense2BiasAddReadVariableOp0bcast;
float * tensor_sequentialdense2BiasAddReadVariableOp0bcast = nullptr;
std::vector<float> fTensor_sequentialdense1Relu0;
float * tensor_sequentialdense1Relu0 = nullptr;
std::vector<float> fTensor_sequentialdense1BiasAdd0;
float * tensor_sequentialdense1BiasAdd0 = nullptr;
std::vector<float> fTensor_sequentialdense1BiasAddReadVariableOp0bcast;
float * tensor_sequentialdense1BiasAddReadVariableOp0bcast = nullptr;
std::vector<float> fTensor_dense2;
float * tensor_dense2 = nullptr;
std::vector<float> fTensor_sequentialdenseRelu0;
float * tensor_sequentialdenseRelu0 = nullptr;
std::vector<float> fTensor_sequentialdenseBiasAdd0;
float * tensor_sequentialdenseBiasAdd0 = nullptr;
std::vector<float> fTensor_sequentialdenseBiasAddReadVariableOp0bcast;
float * tensor_sequentialdenseBiasAddReadVariableOp0bcast = nullptr;


Session(std::string filename ="trained_model.dat",
        size_t unk__6 = 0) {

//--- reading weights from file
   std::ifstream f;
   f.open(filename);
   if (!f.is_open()) {
      throw std::runtime_error("tmva-sofie failed to open file " + filename + " for input weights");
   }
   std::string tensor_name;
   size_t length;
   f >> tensor_name >> length;
   if (tensor_name != "tensor_sequentialdenseBiasAddReadVariableOp0" ) {
      std::string err_msg = "TMVA-SOFIE failed to read the correct tensor name; expected name is tensor_sequentialdenseBiasAddReadVariableOp0 , read " + tensor_name;
      throw std::runtime_error(err_msg);
    }
   if (length != 64) {
      std::string err_msg = "TMVA-SOFIE failed to read the correct tensor size; expected size is 64 , read " + std::to_string(length) ;
      throw std::runtime_error(err_msg);
    }
   for (size_t i = 0; i < length; ++i)
      f >> tensor_sequentialdenseBiasAddReadVariableOp0[i];
   f >> tensor_name >> length;
   if (tensor_name != "tensor_sequentialdenseMatMulReadVariableOp0" ) {
      std::string err_msg = "TMVA-SOFIE failed to read the correct tensor name; expected name is tensor_sequentialdenseMatMulReadVariableOp0 , read " + tensor_name;
      throw std::runtime_error(err_msg);
    }
   if (length != 128) {
      std::string err_msg = "TMVA-SOFIE failed to read the correct tensor size; expected size is 128 , read " + std::to_string(length) ;
      throw std::runtime_error(err_msg);
    }
   for (size_t i = 0; i < length; ++i)
      f >> tensor_sequentialdenseMatMulReadVariableOp0[i];
   f >> tensor_name >> length;
   if (tensor_name != "tensor_sequentialdense1MatMulReadVariableOp0" ) {
      std::string err_msg = "TMVA-SOFIE failed to read the correct tensor name; expected name is tensor_sequentialdense1MatMulReadVariableOp0 , read " + tensor_name;
      throw std::runtime_error(err_msg);
    }
   if (length != 4096) {
      std::string err_msg = "TMVA-SOFIE failed to read the correct tensor size; expected size is 4096 , read " + std::to_string(length) ;
      throw std::runtime_error(err_msg);
    }
   for (size_t i = 0; i < length; ++i)
      f >> tensor_sequentialdense1MatMulReadVariableOp0[i];
   f >> tensor_name >> length;
   if (tensor_name != "tensor_sequentialdense1BiasAddReadVariableOp0" ) {
      std::string err_msg = "TMVA-SOFIE failed to read the correct tensor name; expected name is tensor_sequentialdense1BiasAddReadVariableOp0 , read " + tensor_name;
      throw std::runtime_error(err_msg);
    }
   if (length != 64) {
      std::string err_msg = "TMVA-SOFIE failed to read the correct tensor size; expected size is 64 , read " + std::to_string(length) ;
      throw std::runtime_error(err_msg);
    }
   for (size_t i = 0; i < length; ++i)
      f >> tensor_sequentialdense1BiasAddReadVariableOp0[i];
   f >> tensor_name >> length;
   if (tensor_name != "tensor_sequentialdense2BiasAddReadVariableOp0" ) {
      std::string err_msg = "TMVA-SOFIE failed to read the correct tensor name; expected name is tensor_sequentialdense2BiasAddReadVariableOp0 , read " + tensor_name;
      throw std::runtime_error(err_msg);
    }
   if (length != 1) {
      std::string err_msg = "TMVA-SOFIE failed to read the correct tensor size; expected size is 1 , read " + std::to_string(length) ;
      throw std::runtime_error(err_msg);
    }
   for (size_t i = 0; i < length; ++i)
      f >> tensor_sequentialdense2BiasAddReadVariableOp0[i];
   f >> tensor_name >> length;
   if (tensor_name != "tensor_sequentialdense2MatMulReadVariableOp0" ) {
      std::string err_msg = "TMVA-SOFIE failed to read the correct tensor name; expected name is tensor_sequentialdense2MatMulReadVariableOp0 , read " + tensor_name;
      throw std::runtime_error(err_msg);
    }
   if (length != 64) {
      std::string err_msg = "TMVA-SOFIE failed to read the correct tensor size; expected size is 64 , read " + std::to_string(length) ;
      throw std::runtime_error(err_msg);
    }
   for (size_t i = 0; i < length; ++i)
      f >> tensor_sequentialdense2MatMulReadVariableOp0[i];
   f.close();

//---- allocate the intermediate dynamic tensors
   if (unk__6 * 1 > 0) {
      fTensor_sequentialdense2BiasAddReadVariableOp0bcast.resize(unk__6 * 1);
      tensor_sequentialdense2BiasAddReadVariableOp0bcast = fTensor_sequentialdense2BiasAddReadVariableOp0bcast.data();
   }
   if (unk__6 * 64 > 0) {
      fTensor_sequentialdense1Relu0.resize(unk__6 * 64);
      tensor_sequentialdense1Relu0 = fTensor_sequentialdense1Relu0.data();
   }
   if (unk__6 * 64 > 0) {
      fTensor_sequentialdense1BiasAdd0.resize(unk__6 * 64);
      tensor_sequentialdense1BiasAdd0 = fTensor_sequentialdense1BiasAdd0.data();
   }
   if (unk__6 * 64 > 0) {
      fTensor_sequentialdense1BiasAddReadVariableOp0bcast.resize(unk__6 * 64);
      tensor_sequentialdense1BiasAddReadVariableOp0bcast = fTensor_sequentialdense1BiasAddReadVariableOp0bcast.data();
   }
   if (unk__6 * 1 > 0) {
      fTensor_dense2.resize(unk__6 * 1);
      tensor_dense2 = fTensor_dense2.data();
   }
   if (unk__6 * 64 > 0) {
      fTensor_sequentialdenseRelu0.resize(unk__6 * 64);
      tensor_sequentialdenseRelu0 = fTensor_sequentialdenseRelu0.data();
   }
   if (unk__6 * 64 > 0) {
      fTensor_sequentialdenseBiasAdd0.resize(unk__6 * 64);
      tensor_sequentialdenseBiasAdd0 = fTensor_sequentialdenseBiasAdd0.data();
   }
   if (unk__6 * 64 > 0) {
      fTensor_sequentialdenseBiasAddReadVariableOp0bcast.resize(unk__6 * 64);
      tensor_sequentialdenseBiasAddReadVariableOp0bcast = fTensor_sequentialdenseBiasAddReadVariableOp0bcast.data();
   }
//--- broadcast bias tensor sequentialdenseBiasAddReadVariableOp0for Gemm op
   {
      float * data = TMVA::Experimental::SOFIE::UTILITY::UnidirectionalBroadcast<float>(tensor_sequentialdenseBiasAddReadVariableOp0,{ 64 }, { unk__6 , 64 });
      std::copy(data, data + unk__6 * 64, tensor_sequentialdenseBiasAddReadVariableOp0bcast);
      delete [] data;
   }
//--- broadcast bias tensor sequentialdense1BiasAddReadVariableOp0for Gemm op
   {
      float * data = TMVA::Experimental::SOFIE::UTILITY::UnidirectionalBroadcast<float>(tensor_sequentialdense1BiasAddReadVariableOp0,{ 64 }, { unk__6 , 64 });
      std::copy(data, data + unk__6 * 64, tensor_sequentialdense1BiasAddReadVariableOp0bcast);
      delete [] data;
   }
//--- broadcast bias tensor sequentialdense2BiasAddReadVariableOp0for Gemm op
   {
      float * data = TMVA::Experimental::SOFIE::UTILITY::UnidirectionalBroadcast<float>(tensor_sequentialdense2BiasAddReadVariableOp0,{ 1 }, { unk__6 , 1 });
      std::copy(data, data + unk__6 * 1, tensor_sequentialdense2BiasAddReadVariableOp0bcast);
      delete [] data;
   }
}

std::vector<float> infer(size_t unk__6,float* tensor_sequential){

//--------- Gemm
   char op_0_transA = 'n';
   char op_0_transB = 'n';
   int op_0_m = unk__6;
   int op_0_n = 64;
   int op_0_k = 2;
   float op_0_alpha = 1;
   float op_0_beta = 1;
   int op_0_lda = 2;
   int op_0_ldb = 64;
   std::copy(tensor_sequentialdenseBiasAddReadVariableOp0bcast, tensor_sequentialdenseBiasAddReadVariableOp0bcast + unk__6 * 64, tensor_sequentialdenseBiasAdd0);
   BLAS::sgemm_(&op_0_transB, &op_0_transA, &op_0_n, &op_0_m, &op_0_k, &op_0_alpha, tensor_sequentialdenseMatMulReadVariableOp0, &op_0_ldb, tensor_sequential, &op_0_lda, &op_0_beta, tensor_sequentialdenseBiasAdd0, &op_0_n);

//------ RELU
   for (int id = 0; id < unk__6 * 64 ; id++){
      tensor_sequentialdenseRelu0[id] = ((tensor_sequentialdenseBiasAdd0[id] > 0 )? tensor_sequentialdenseBiasAdd0[id] : 0);
   }

//--------- Gemm
   char op_2_transA = 'n';
   char op_2_transB = 'n';
   int op_2_m = unk__6;
   int op_2_n = 64;
   int op_2_k = 64;
   float op_2_alpha = 1;
   float op_2_beta = 1;
   int op_2_lda = 64;
   int op_2_ldb = 64;
   std::copy(tensor_sequentialdense1BiasAddReadVariableOp0bcast, tensor_sequentialdense1BiasAddReadVariableOp0bcast + unk__6 * 64, tensor_sequentialdense1BiasAdd0);
   BLAS::sgemm_(&op_2_transB, &op_2_transA, &op_2_n, &op_2_m, &op_2_k, &op_2_alpha, tensor_sequentialdense1MatMulReadVariableOp0, &op_2_ldb, tensor_sequentialdenseRelu0, &op_2_lda, &op_2_beta, tensor_sequentialdense1BiasAdd0, &op_2_n);

//------ RELU
   for (int id = 0; id < unk__6 * 64 ; id++){
      tensor_sequentialdense1Relu0[id] = ((tensor_sequentialdense1BiasAdd0[id] > 0 )? tensor_sequentialdense1BiasAdd0[id] : 0);
   }

//--------- Gemm
   char op_4_transA = 'n';
   char op_4_transB = 'n';
   int op_4_m = unk__6;
   int op_4_n = 1;
   int op_4_k = 64;
   float op_4_alpha = 1;
   float op_4_beta = 1;
   int op_4_lda = 64;
   int op_4_ldb = 1;
   std::copy(tensor_sequentialdense2BiasAddReadVariableOp0bcast, tensor_sequentialdense2BiasAddReadVariableOp0bcast + unk__6 * 1, tensor_dense2);
   BLAS::sgemm_(&op_4_transB, &op_4_transA, &op_4_n, &op_4_m, &op_4_k, &op_4_alpha, tensor_sequentialdense2MatMulReadVariableOp0, &op_4_ldb, tensor_sequentialdense1Relu0, &op_4_lda, &op_4_beta, tensor_dense2, &op_4_n);
   std::vector<float> ret (tensor_dense2, tensor_dense2 + unk__6 * 1);
   return ret;
}
};
} //TMVA_SOFIE_trained_model

#endif  // ROOT_TMVA_SOFIE_TRAINED_MODEL
